"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var calcLinksToDisplay_1 = __importDefault(require("./calcLinksToDisplay"));
var Pagination_1 = __importDefault(require("react-bootstrap/Pagination"));
var ELLIPSIS_MARK = -1;
var PaginationWrapper = /** @class */ (function (_super) {
    __extends(PaginationWrapper, _super);
    function PaginationWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PaginationWrapper.prototype.handleClickF = function (page) {
        var _this = this;
        return function () {
            var _a = _this.props, onChange = _a.onChange, name = _a.name;
            if (!onChange) {
                console.warn('onChange() method is not set for PaginationWrapper ("'
                    + name + '"), but page change occurs');
                return;
            }
            return onChange({ target: { name: name, value: page } });
        };
    };
    PaginationWrapper.prototype.render = function () {
        var _this = this;
        /* eslint @typescript-eslint/no-unused-vars: [2, {"varsIgnorePattern": "(onChange|name)"}] */
        var _a = this.props, atBeginEnd = _a.atBeginEnd, aroundCurrent = _a.aroundCurrent, onChange = _a.onChange, disabled = _a.disabled, name = _a.name, readOnly = _a.readOnly, showFirstLast = _a.showFirstLast, showPrevNext = _a.showPrevNext, totalPages = _a.totalPages, value = _a.value, etc = __rest(_a, ["atBeginEnd", "aroundCurrent", "onChange", "disabled", "name", "readOnly", "showFirstLast", "showPrevNext", "totalPages", "value"]);
        var linksToDisplay = calcLinksToDisplay_1.default(totalPages, value, atBeginEnd, aroundCurrent, ELLIPSIS_MARK);
        var allDisabled = disabled || readOnly;
        return react_1.default.createElement(Pagination_1.default, __assign({}, etc),
            showFirstLast && (value <= 0 || allDisabled
                ? react_1.default.createElement(Pagination_1.default.First, { disabled: true, key: "-2" })
                : react_1.default.createElement(Pagination_1.default.First, { key: "-2", onClick: this.handleClickF(0) })),
            showPrevNext && (value <= 0 || allDisabled
                ? react_1.default.createElement(Pagination_1.default.Prev, { disabled: true, key: "-1" })
                : react_1.default.createElement(Pagination_1.default.Prev, { key: "-1", onClick: this.handleClickF(value - 1) })),
            linksToDisplay.map(function (p, index) {
                return p === value
                    ? react_1.default.createElement(Pagination_1.default.Item, { active: true, key: p }, p + 1)
                    : p === ELLIPSIS_MARK
                        ? react_1.default.createElement(Pagination_1.default.Ellipsis, { disabled: true, key: "_" + index })
                        : allDisabled
                            ? react_1.default.createElement(Pagination_1.default.Item, { disabled: true, key: p }, p + 1)
                            : react_1.default.createElement(Pagination_1.default.Item, { href: "#", key: p, onClick: _this.handleClickF(p) }, p + 1);
            }),
            showPrevNext && (value >= totalPages - 1 || allDisabled
                ? react_1.default.createElement(Pagination_1.default.Next, { disabled: true, key: "+1" })
                : react_1.default.createElement(Pagination_1.default.Next, { key: "+1", onClick: this.handleClickF(value + 1) })),
            showFirstLast && (value >= totalPages - 1 || allDisabled
                ? react_1.default.createElement(Pagination_1.default.Last, { disabled: true, key: "+2" })
                : react_1.default.createElement(Pagination_1.default.Last, { key: "+2", onClick: this.handleClickF(totalPages - 1) })));
    };
    PaginationWrapper.defaultProps = {
        atBeginEnd: 2,
        aroundCurrent: 1,
        name: 'page',
        showFirstLast: true,
        showPrevNext: true,
    };
    return PaginationWrapper;
}(react_1.PureComponent));
exports.default = PaginationWrapper;
